case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac

case "$d_strstr" in
define)	strsrc= strobj= ;;
*)	strsrc="strstr.c"
	strobj="strstr.o"
	;;
esac

case "$d_strftime" in
define)	ftimesrc= ftimeobj= ;;
*)	ftimesrc="strftime.c"
	ftimeobj="strftime.o"
	;;
esac

case "$d_msgcat" in
define) msgcatsrc= msgcatobj= ;;
*)      msgcatsrc=msgcat.c
        msgcatobj=msgcat.o
	;;
esac

case "$d_dlopen_libs" in
define)  sharedsrc="shared.c shared_connect.c shared_base.c shared_all.c"
	 sharedobj="shared.o shared_connect.o shared_base.o shared_all.o"
	 ;;
*)	 sharedsrc=
	 sharedobj=
	;;
esac

echo "Extracting lib/Makefile (with variable substitutions)"
cat >Makefile <<!GROK!THIS!
#!$make
# $Id: Makefile.SH,v 1.89.8.1 2004/04/18 16:55:36 hurtta Exp $
#
#  Makefile for the ELM mail program.
#
#	Copyright (c) 1986,1987 Dave Taylor
#	Copyright (c) 1988-1992 USENET Community Trust
#
#
#
# Variables
#	Variables established by Configure
AR		=	ar
CC		=	$cc
CCFLAGS		=	$ccflags $picflag $xencf
CP		=	$cp
CHMOD		=	$chmod
LINT		=	$lint
OPTIMIZE	=	$optimize
RANLIB		=	$ranlib
RM		= 	$rm -f
MV		=	$mv
TOUCH		=	$touch
TAGS		=	ctags

EGREP		=	$egrep
SORT		=	$sort
DIFF		=	$diff 

STRSRC		=	$strsrc
STROBJ		=	$strobj

FTIMESRC	=	$ftimesrc
FTIMEOBJ	=	$ftimeobj

MSGCATSRC	=	$msgcatsrc
MSGCATOBJ	=	$msgcatobj

SHAREDSRC	=	$sharedsrc
SHAREDOBJ	=	$sharedobj

!GROK!THIS!

case "$ccflags" in
	*-DDEBUG*)
cat >>Makefile <<SUBSTITUTE
DEBUGSRC = debug.c
DEBUGOBJ = debug.o
SUBSTITUTE
	;;
	*)
cat >>Makefile <<SUBSTITUTE
DEBUGSRC = 
DEBUGOBJ = 
SUBSTITUTE
	;;
esac

if $test "$d_shared" = "$define" ; then

	A=
	if $test "$soname_include_path" = "$define" ; then
		A="$shlib/"
	fi

cat >>Makefile <<SUBSTITUTE
SHLIST          = ../shlib/libelmme-base.so
INSTLIB		= $shlib/libelmme-base.so$d_shared_rev
SONAME          = ${soname_opt}${A}libelmme-base.so$d_shared_rev
SHLIB		= $shlib
SUBSTITUTE

else

cat >>Makefile <<'!NO!SUBS!'
SHLIST          =
INSTLIB         =
SONAME		=
SHLIB		= 
!NO!SUBS!

fi

$cat >>Makefile <<'!NO!SUBS!'

#	Other general variables
CFLAGS		=	-I$(INCLDIR) $(CCFLAGS) $(OPTIMIZE) 
INCLDIR		=	../hdrs
LINTFLAGS	=	-I$(INCLDIR)
SHELL		=	/bin/sh
REG		=	../bin/elmregister

# 	Lists
LIB_SRC		=	add_site.c	\
			atonum.c	\
			bindata.c	\
			mmaputil.c	\
			mk_aliases.c	\
			aliasdb.c	\
			mk_lockname.c	\
			can_access.c	\
			can_open.c	\
			chloc.c		\
			charset.c       \
			precompiled_sets.c \
			charset_input.c \
			cs_binary.c	\
			cs_iso2022.c	\
			cs_fallback.c   \
			cs_utf.c        \
			date_util.c	\
			$(DEBUGSRC)	\
			dispaddr.c	\
			dynarray.c	\
			errno.c		\
			expand.c	\
			expires.c	\
			forwarded.c     \
			file_util.c     \
			gcos_name.c	\
			getaddr.c	\
			getaddr.c	\
			getaddrfrm.c	\
			getarpdate.c	\
			getfullnam.c	\
			getword.c	\
			get_tz.c	\
			hdrdecode.c	\
			hdrencode.c	\
			header_cmp.c	\
			headers.c	\
			id_phrase.c	\
			in_string.c	\
			imap.c		\
			iso2022.c 	\
			iso2022_map.c	\
			istrcmp.c	\
			ldstate.c	\
			len_next.c	\
			localmbx.c 	\
			mail_gets.c	\
			mailer.c	\
			mediatype.c	\
			mbox.c		\
			move_left.c	\
			$(MSGCATSRC)	\
			ndbz.c		\
			okay_addr.c	\
			opt_utils.c	\
			outheaders.c	\
			output.c        \
			panic.c		\
			parsarpdat.c	\
			pmalloc.c	\
			posixsig.c	\
			pop.c		\
			putenv.c	\
			realfrom.c	\
			remote_mbx.c	\
			qstrings.c	\
			rc_handle.c	\
			read_rc.c       \
			reverse.c	\
			rfc822tlen.c	\
			stringtok.c	\
			safemalloc.c	\
			savefolder.c	\
			$(SHAREDSRC)	\
			sb_file.c       \
			sb_mem.c        \
			schedule.c	\
			service_list.c	\
			shiftlower.c	\
			state.c		\
			streamsched.c	\
			strfcpy.c	\
			strincmp.c	\
			string.c	\
			stringbuffer.c	\
			striparens.c	\
			$(STRSRC)	\
			$(FTIMESRC)	\
			strmcpy.c	\
			strtokq.c	\
			syscall.c	\
			terminal.c	\
			unicode.c	\
			unidata.c	\
			write_hdr.c	\
			safeopen.c

LIB_OBJ		=	add_site.o	\
			atonum.o	\
			bindata.o	\
			mmaputil.o	\
			mk_aliases.o	\
			aliasdb.o	\
			mk_lockname.o	\
			can_access.o	\
			can_open.o	\
			chloc.o		\
			charset.o       \
			precompiled_sets.o \
			charset_input.o \
			cs_binary.o	\
			cs_iso2022.o	\
			cs_fallback.o	\
			cs_utf.o	\
			date_util.o	\
			$(DEBUGOBJ)	\
			dispaddr.o	\
			dynarray.o	\
			errno.o		\
			expand.o	\
			expires.o	\
			forwarded.o     \
			file_util.o     \
			gcos_name.o	\
			get_tz.o	\
			hdrdecode.o	\
			hdrencode.o	\
			headers.o	\
			getaddr.o	\
			getaddrfrm.o	\
			getarpdate.o	\
			getfullnam.o	\
			getword.o	\
			header_cmp.o	\
			id_phrase.o	\
			in_string.o	\
			iso2022.o 	\
			iso2022_map.o	\
			imap.o		\
			istrcmp.o	\
			ldstate.o	\
			len_next.o	\
			localmbx.o	\
			mail_gets.o	\
			mailer.o	\
			mediatype.o	\
			mbox.o		\
			move_left.o	\
			$(MSGCATOBJ)	\
			ndbz.o		\
			okay_addr.o	\
			opt_utils.o	\
			outheaders.o	\
			output.o	\
			panic.o		\
			parsarpdat.o	\
			pmalloc.o	\
			posixsig.o	\
			pop.o		\
			putenv.o	\
			qstrings.o	\
			rc_handle.o	\
			read_rc.o	\
			realfrom.o	\
			remote_mbx.o	\
			reverse.o	\
			rfc822tlen.o	\
			stringtok.o	\
			safemalloc.o	\
			savefolder.o	\
			$(SHAREDOBJ)	\
			sb_file.o       \
			sb_mem.o        \
			schedule.o	\
			service_list.o	\
			shiftlower.o	\
			state.o		\
			streamsched.o	\
			strfcpy.o	\
			strincmp.o	\
			string.o	\
			stringbuffer.o	\
			striparens.o	\
			$(STROBJ)	\
			$(FTIMEOBJ)	\
			strmcpy.o	\
			strtokq.o	\
			syscall.o	\
			terminal.o	\
			unicode.o	\
			unidata.o	\
			write_hdr.o	\
			safeopen.o

all:			magic_diffs Makefile libutil.a $(SHLIST)

install_s:	Makefile libutil.a $(INSTLIB)

uninstall_s:		
	$(REG) rm $(INSTLIB)

libutil.a:		$(LIB_OBJ)
			$(AR) r $@ $?
			$(RANLIB) $@

Makefile: Makefile.SH ../config.sh
	@echo "You must run 'sh Configure -S' or 'sh Configure'"
	exit 1

magic_diffs:	MAGIC
		$(EGREP) -h '#define .*_magic' ../*/*.[ch] ../*/*/*.[ch] | $(SORT) > magic_res1
		$(SORT) < MAGIC > magic_res2		
		@if $(DIFF) -c -b magic_res1 magic_res2 > magic_diffs; then  \
		   echo "lib/MAGIC OK" ; \
                else \
                   echo "lib/MAGIC NOT up of date !!!" ; \
                   cat magic_diffs ; \
	           exit 1; \
                fi

lint:		
		$(LINT) $(LINTFLAGS) $(LIB_SRC) > LINT.OUT

tags:
		$(TAGS) $(LIB_SRC)

clean:		
		$(RM) $(LIB_OBJ) libutil.a

# Dependencies and rules
#	Dependencies of header files upon other header files they include
.PRECIOUS:		$(INCLDIR)/elm_defs.h $(INCLDIR)/shared_imp.h \
 $(INCLDIR)/defs_major.h

$(INCLDIR)/elm_defs.h:	$(INCLDIR)/defs_major.h $(INCLDIR)/elm_nl_types.h \
 $(INCLDIR)/elmlib.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(INCLDIR)/defs_major.h: $(INCLDIR)/../config.h $(INCLDIR)/sysdefs.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(INCLDIR)/shared_imp.h:	 ../shared_libs/include/shared.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

#	Dependencies of C object files
# Simple files ...
putenv.o:	$(INCLDIR)/defs_major.h
strstr.o:	$(INCLDIR)/defs_major.h
safeopen.o:	$(INCLDIR)/defs_major.h

# ---   Dependencies of C object files
add_site.o:	$(INCLDIR)/elm_defs.h
atonum.o:	$(INCLDIR)/elm_defs.h
bindata.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/mmaputil.h \
 $(INCLDIR)/cs_imp.h $(INCLDIR)/s_me.h $(INCLDIR)/bindata.h
mmaputil.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/mmaputil.h
dynarray.o:	$(INCLDIR)/elm_defs.h
mk_aliases.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/ndbz.h $(INCLDIR)/s_newalias.h
aliasdb.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/ndbz.h
mk_lockname.o:	$(INCLDIR)/elm_defs.h
can_access.o:	$(INCLDIR)/elm_defs.h
can_open.o:	$(INCLDIR)/elm_defs.h
chloc.o:	$(INCLDIR)/elm_defs.h
charset.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/cs_imp.h \
 $(INCLDIR)/shared_imp.h
precompiled_sets.o: $(INCLDIR)/cs_imp.h $(INCLDIR)/elmlib.h $(INCLDIR)/elm_defs.h
charset_input.o: $(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/cs_imp.h
cs_binary.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/cs_imp.h \
 $(INCLDIR)/bindata.h
cs_fallback.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/cs_imp.h
cs_utf.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/cs_imp.h
cs_iso2022.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/cs_imp.h $(INCLDIR)/cs_terminal.h
date_util.o:	$(INCLDIR)/elm_defs.h
debug.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h $(INCLDIR)/patchlevel.h
dispaddr.o:     $(INCLDIR)/elm_defs.h
errno.o:	$(INCLDIR)/elm_defs.h
expand.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elmrc.h 
expires.o:	$(INCLDIR)/elm_defs.h
forwarded.o:	$(INCLDIR)/elm_defs.h
file_util.o:    $(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h  $(INCLDIR)/s_me.h 
gcos_name.o:	$(INCLDIR)/elm_defs.h
get_tz.o:	$(INCLDIR)/elm_defs.h
getaddr.o:	$(INCLDIR)/elm_defs.h
getaddrfrm.o:	$(INCLDIR)/elm_defs.h
getarpdate.o:	$(INCLDIR)/elm_defs.h
getfullnam.o:	$(INCLDIR)/elm_defs.h
getword.o:	$(INCLDIR)/elm_defs.h
hdrdecode.o:  	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h  
hdrencode.o:  	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h  
header_cmp.o:	$(INCLDIR)/elm_defs.h
headers.o: 	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/hdr_imp.h
in_string.o:	$(INCLDIR)/elm_defs.h
iso2022.o: 	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/cs_imp.h
iso2022_map.o: 	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/cs_imp.h
imap.o:		$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h $(INCLDIR)/s_me.h \
 $(INCLDIR)/mbx_imp.h $(INCLDIR)/ss_imp.h
istrcmp.o:	$(INCLDIR)/elm_defs.h
ldstate.o:	$(INCLDIR)/elm_defs.h
len_next.o:	$(INCLDIR)/elm_defs.h
localmbx.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h $(INCLDIR)/s_me.h \
 $(INCLDIR)/mbx_imp.h
mail_gets.o:	$(INCLDIR)/elm_defs.h
mailer.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h \
 $(INCLDIR)/mailer_imp.h $(INCLDIR)/shared_imp.h
mediatype.o:	$(INCLDIR)/elm_defs.h
mbox.o:		$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h $(INCLDIR)/s_me.h \
 $(INCLDIR)/mbx_imp.h $(INCLDIR)/shared_imp.h
move_left.o:	$(INCLDIR)/elm_defs.h
msgcat.o:	$(INCLDIR)/msgcat.h $(INCLDIR)/elm_defs.h
ndbz.o:		$(INCLDIR)/elm_defs.h $(INCLDIR)/ndbz.h
okay_addr.o:	$(INCLDIR)/elm_defs.h
opt_utils.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_error.h
outheaders.o: 	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/hdr_imp.h
id_phrase.o:	$(INCLDIR)/elm_defs.h 
output.o:	$(INCLDIR)/elm_defs.h
panic.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h
parsarpdat.o:	$(INCLDIR)/elm_defs.h
pmalloc.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h
pop.o:		$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h $(INCLDIR)/s_me.h \
 $(INCLDIR)/mbx_imp.h $(INCLDIR)/ss_imp.h
posixsig.o:	$(INCLDIR)/elm_defs.h
rc_handle.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/save_opts.h \
 $(INCLDIR)/s_elm.h $(INCLDIR)/rc_imp.h $(INCLDIR)/shared_imp.h
read_rc.o:      $(INCLDIR)/elm_defs.h $(INCLDIR)/save_opts.h \
 $(INCLDIR)/s_elm.h $(INCLDIR)/s_me.h $(INCLDIR)/rc_imp.h \
 $(INCLDIR)/unidata.h $(INCLDIR)/cs_imp.h
realfrom.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h 
remote_mbx.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h $(INCLDIR)/s_me.h \
 $(INCLDIR)/mbx_imp.h $(INCLDIR)/shared_imp.h $(INCLDIR)/ss_imp.h
qstrings.o:	$(INCLDIR)/elm_defs.h
reverse.o:	$(INCLDIR)/elm_defs.h
rfc822tlen.o:	$(INCLDIR)/elm_defs.h
stringtok.o:	$(INCLDIR)/elm_defs.h
safemalloc.o:	$(INCLDIR)/elm_defs.h
savefolder.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/mbx_imp.h
shared.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h \
 $(INCLDIR)/shared_imp.h $(INCLDIR)/mbx_imp.h $(INCLDIR)/save_opts.h \
 $(INCLDIR)/rc_imp.h $(INCLDIR)/cs_imp.h $(INCLDIR)/ss_imp.h \
 $(INCLDIR)/mailer_imp.h
shared_connect.o:  $(INCLDIR)/elm_defs.h \
 $(INCLDIR)/shared_imp.h $(INCLDIR)/save_opts.h $(INCLDIR)/cs_imp.h  \
 $(INCLDIR)/mbx_imp.h $(INCLDIR)/ss_imp.h $(INCLDIR)/mailer_imp.h
shared_base.o:  $(INCLDIR)/elm_defs.h \
 $(INCLDIR)/shared_imp.h $(INCLDIR)/save_opts.h $(INCLDIR)/cs_imp.h 
shared_all.o:  $(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h \
 $(INCLDIR)/shared_imp.h $(INCLDIR)/save_opts.h $(INCLDIR)/cs_imp.h 
sb_file.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/sb_imp.h
sb_mem.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/sb_imp.h
schedule.o:	$(INCLDIR)/elm_defs.h
service_list.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h $(INCLDIR)/s_me.h \
 $(INCLDIR)/mbx_imp.h $(INCLDIR)/shared_imp.h $(INCLDIR)/ss_imp.h
shiftlower.o:	$(INCLDIR)/elm_defs.h
state.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h  
streamsched.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/ss_imp.h $(INCLDIR)/mbx_imp.h \
 $(INCLDIR)/shared_imp.h
strfcpy.o:      $(INCLDIR)/elm_defs.h
strftime.o:     $(INCLDIR)/elm_defs.h
string.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/cs_imp.h \
 $(INCLDIR)/shared_imp.h
stringbuffer.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/sb_imp.h
strmcpy.o:      $(INCLDIR)/elm_defs.h
strincmp.o:	$(INCLDIR)/elm_defs.h
striparens.o:	$(INCLDIR)/elm_defs.h
strtokq.o:	$(INCLDIR)/elm_defs.h
syscall.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_elm.h  
terminal.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/cs_imp.h $(INCLDIR)/cs_terminal.h
unicode.o:	$(INCLDIR)/elm_defs.h $(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/cs_imp.h \
 $(INCLDIR)/unidata.h
unidata.o:      $(INCLDIR)/elm_defs.h $(INCLDIR)/s_me.h $(INCLDIR)/unidata.h
write_hdr.o:	$(INCLDIR)/elm_defs.h
!NO!SUBS!

if $test "$d_shared" = "$define" ; then

cat >>Makefile <<'!NO!SUBS!'
../shlib/libelmme-base.so: $(LIB_OBJ)
		$(CC) $(CCFLAGS) $(SONAME) -o $@ $(LIB_OBJ)

$(SHLIB):
		$(REG) mkdir $(SHLIB)

$(INSTLIB):	$(SHLIB) ../shlib/libelmme-base.so
		$(REG) copy -m 444 ../shlib/libelmme-base.so $@
!NO!SUBS!

else

cat >>Makefile <<'!NO!SUBS!'

!NO!SUBS!

fi



